local M = {}

local i = 0
local gyroToggle = 0
local autoAltitude = 0
local requiredAutoAltitude = 0;
local requiredPower = 0;

local function onInit()
	electrics.values.gyro = 1;
end


function gyro(input, currentAngle, reactionFactor, maxAngle, trim)
   input = toGyro(input)   
   inputProcent = input/0.5;
   requiredAngle = inputProcent * maxAngle; 
   diff = (currentAngle-requiredAngle)+trim;
   output = diff * diff / reactionFactor ;
   if output > 0.5 then output  = 0.5 end
   if diff < 0 then output  = output * -1 end
   return fromGyro(output) ; 
end

function toGyro(input)
	return input - 0.5;
end

function fromGyro(input)
	return input + 0.5;
end

function gyroToStr(gyro)
	if gyro ~= 0 then
		return "On"
	end
	return "Off"
end

local function updateGFX(dt)

	electrics.values.power = electrics.values.rpm / 10000
	power = electrics.values.power;

	if gyroToggle ~= (electrics.values.gyro or gyroToggle) then
		gyroToggle = electrics.values.gyro;
        gui.message(string.format('Gyro is %s',gyroToStr(gyroToggle)), 2, "gyro")
	end
	
	if autoAltitude ~= (electrics.values.autoAltitude or autoAltitude) then
		autoAltitude = electrics.values.autoAltitude;
		requiredPower = power;
        gui.message(string.format('AutoAltitude is %s',gyroToStr(autoAltitude)), 2, "autoAltitude")
		requiredAutoAltitude = electrics.values.altitude
	end

	
	if autoAltitude ~= 0 then
	
		power = requiredPower
		--gyro(( 1.0) , electrics.values.altitude, 2000, 100000, requiredAutoAltitude);
		electrics.values.rpm = power

	end
	
	if gyroToggle ~= 0 then
		local dirVector = obj:getDirectionVector()
		local dirVectorUp = obj:getDirectionVectorUp()
		
		electrics.values.rollDeg = -(dirVectorUp.x * -dirVector.y + dirVectorUp.y * dirVector.x) * 90;
		electrics.values.pitchDeg = dirVector.z * 90;
		
		-- Sidewise
		movex = gyro((electrics.values.moveSide or 0.5) , electrics.values.rollDeg, 1000, 20, 10);
		moveSide = (math.floor(movex *100)/10-5)/30;
		electrics.values.turbineR = (power or 0) + (moveSide or 0)
		electrics.values.turbineL = (power or 0) - (moveSide or 0)
		
		-- Forward
		movey = gyro(1-(electrics.values.moveFwd or 0.5) , electrics.values.pitchDeg, 4000, 40, 20)-0.5;
		moveSidey = (math.floor((electrics.values.moveSide or 0.5) *100)/10-5)/25;
		electrics.values.turbineFwdL  = (movey+moveSidey);
		electrics.values.turbineFwdR  = (movey-moveSidey);
	
	else
		movey = (electrics.values.moveFwd or 0.5);
		electrics.values.turbineFwdL  = (movey);
		electrics.values.turbineFwdR  = (movey);		
		moveSide = (math.floor((electrics.values.moveSide or 0.5) *100)/10-5)/30;
		electrics.values.turbineR = (electrics.values.power or 0) + (moveSide or 0)
		electrics.values.turbineL = (electrics.values.power or 0) - (moveSide or 0)		
	end


	
    i = i + 1;
    if i and ( i > 10 )  then
	
         --gui.message(string.format('power:%s',tostring(power)))
        -- gui.message(string.format('rollDeg:%s, pitchDeg:%s',tostring(electrics.values.rollDeg),tostring(electrics.values.pitchDeg)
        --gui.message(string.format('moveSide: %s, turbineR: %s, turbineL: %s',tostring(movex or 0),tostring(electrics.values.turbineR or 0),tostring(electrics.values.turbineL or 0)), 2, "gearshift")
		i = 0
    end
	electrics.values.wheelspeed = electrics.values.airspeed	
end

M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX


return M